#!/usr/bin/perl

#   
#   Copyright 2014 NQuiX Ltd
#
#   Licensed under the Apache License, Version 2.0 (the 'License');
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the license at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#

use strict;
use warnings;

my $id;
my $tan;
my $idx;
my $filename;
my %mintan;
my %idxlow;
my $key;

while ($filename=shift(@ARGV)) {
    open FILE, $filename or die $!;
    while (<FILE>) {
	chomp;
	($id, $tan, $idx) = split (/\s+/, $_, 3);
	if ($id ne "ID") {
	    if ((!defined($mintan{$id})) || ($tan < $mintan{$id})) {
		$mintan{$id} = $tan;
		$idxlow{$id} = $idx;
	    }
	}
    }
    close FILE;
}

foreach $key (keys %mintan) {
    printf (STDOUT "$key $mintan{$key} $idxlow{$key}\n");
}
