#!/usr/bin/perl

#
#   Copyright 2014 NQuiX Ltd
#
#   Licensed under the Apache License, Version 2.0 (the 'License');
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the license at:
#
#   http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#

use strict;
use warnings;

my $line;
my $lowtan;
my $id;
my $scores;
my $tan;
my $euc;
my $col;
my $lowcol;
my $offset;
my $factor;

if ($offset = shift (@ARGV)) {
    if ($factor = shift (@ARGV)) {
	$offset *= $factor;
    }
} else {
    $offset = 0;
}

while ($line = <STDIN>) {
	$lowtan = 1.0;
	$col = 1;
	($id, $scores) = split (/\s+/, $line, 2);
	while (($tan, $euc, $scores) = split (/\s+/, $scores, 3)) {
		if ($tan < $lowtan) {
			$lowtan = $tan;
			$lowcol = $offset + $col;
		}
		$col++;
	}
	if ($id ne "id") {
	    printf ("$id $lowtan $lowcol\n");
	} else {
	    printf ("ID Tanimoto Sim-Mol\n");
	}
}	
